import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["href", "size", "ratio", "shape", "target", "captionText", "linkFactory"],
    _excluded2 = ["children"];
import PropTypes from 'prop-types';
import AtomImage from '@s-ui/react-atom-image';
import cx from 'classnames';
import { BASE_CLASS, CAPTION_CLASS, CONTAINER_IMAGE, LINK_CLASS, THUMBNAIL_RATIOS, THUMBNAIL_SHAPES, THUMBNAIL_SIZES } from './settings';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";

var MoleculeThumbnail = function MoleculeThumbnail(props) {
  var href = props.href,
      size = props.size,
      ratio = props.ratio,
      shape = props.shape,
      target = props.target,
      captionText = props.captionText,
      Link = props.linkFactory,
      propsImage = _objectWithoutPropertiesLoose(props, _excluded);

  var ImageCaption = function ImageCaption() {
    return /*#__PURE__*/_jsxs("div", {
      children: [/*#__PURE__*/_jsx("div", {
        className: cx("" + CONTAINER_IMAGE, CONTAINER_IMAGE + "--" + ratio),
        children: /*#__PURE__*/_jsx(AtomImage, _extends({}, propsImage))
      }), captionText && /*#__PURE__*/_jsx("figcaption", {
        className: CAPTION_CLASS,
        children: captionText
      })]
    });
  };

  return /*#__PURE__*/_jsx("figure", {
    className: cx("" + BASE_CLASS, BASE_CLASS + "--" + size, BASE_CLASS + "--" + shape),
    children: href ? /*#__PURE__*/_jsx(Link, {
      className: LINK_CLASS,
      href: href,
      target: target,
      rel: target === '_blank' ? 'noopener' : undefined,
      children: /*#__PURE__*/_jsx(ImageCaption, {})
    }) : /*#__PURE__*/_jsx(ImageCaption, {})
  });
};

MoleculeThumbnail.displayName = 'MoleculeThumbnail';
MoleculeThumbnail.defaultProps = {
  // eslint-disable-next-line react/prop-types
  linkFactory: function linkFactory(_temp) {
    var _ref = _temp === void 0 ? {} : _temp,
        children = _ref.children,
        rest = _objectWithoutPropertiesLoose(_ref, _excluded2);

    return /*#__PURE__*/_jsx("a", _extends({}, rest, {
      children: children
    }));
  },
  ratio: THUMBNAIL_RATIOS['1:1'],
  shape: THUMBNAIL_SHAPES.SQUARED,
  size: THUMBNAIL_SIZES.MEDIUM,
  target: '_blank'
};
export default MoleculeThumbnail;
export { THUMBNAIL_RATIOS as moleculeThumbnailRatio, THUMBNAIL_SHAPES as moleculeThumbnailShape, THUMBNAIL_SIZES as moleculeThumbnailSize };